您的位置:首页 > 其它

HDU - 1081 To The Max ( 最大子矩阵)

2017-08-09 22:17 375 查看


To The Max

Problem Description

Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. In this problem the
sub-rectangle with the largest sum is referred to as the maximal sub-rectangle.

As an example, the maximal sub-rectangle of the array:

0 -2 -7 0

9 2 -6 2

-4 1 -4 1

-1 8 0 -2

is in the lower left corner:

9 2

-4 1

-1 8

and has a sum of 15.

 

Input

The input consists of an N x N array of integers. The input begins with a single positive integer N on a line by itself, indicating the size of the square two-dimensional array. This is followed by N 2 integers separated by whitespace (spaces and newlines).
These are the N 2 integers of the array, presented in row-major order. That is, all numbers in the first row, left to right, then all numbers in the second row, left to right, etc. N may be as large as 100. The numbers in the array will be in the range [-127,127].

 

Output

Output the sum of the maximal sub-rectangle.

 

Sample Input

4
0 -2 -7 0 9 2 -6 2
-4 1 -4 1 -1
8 0 -2

 

Sample Output

15

 

题意:最大子矩阵和

解题思路:因为是连续的,所以一切都很简单,稍微思考就可以转化为最大连续子段和的问题了。我们枚举由行组成的连续矩阵,然后对每个矩阵的每一列求和,然后求最大连续子段和就可以了。

#include<iostream>
#include<memory.h>
#include<string>
#include<algorithm>

using namespace std;
const int MAXN=105;
int dp[MAXN];//保存从0~i的最大和
int a[MAXN][MAXN];
int N;

int temp[MAXN];//暂时保存每一列的和

//求最大连续子段和
int getZDLXZDH(){
dp[0]=temp[0];
int maxsum=dp[0];
for(int i=1;i<N;i++){
if(dp[i-1]>=0)
dp[i]=dp[i-1]+temp[i];
else
dp[i]=temp[i];

if(dp[i]>maxsum)
maxsum=dp[i];

}
return maxsum;
}

int main(){

while(~scanf("%d",&N)){

for(int i=0;i<N;i++)
for(int j=0;j<N;j++)
scanf("%d",&a[i][j]);

int ans=-99999999;
for(int i=0;i<N;i++)//从第i行开始
{
memset(temp,0,sizeof(temp));
for(int j=i;j<N;j++)//从 i行到 n-1行都枚举一次
{
for(int k=0;k<N;k++)//把 j至 k行的每一列都加起来
temp[k]+=a[j][k];

int pre=getZDLXZDH();//计算压缩矩阵形成的一维数组的最长连续序列
if(ans<pre)//更新最大值
ans=pre;
}
}
printf("%d\n",ans);

}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: